<%@ page import="database.*,entities.Statistics"%>
<%@ page language="java" contentType="text/html; charset=ISO-8859-1"
	pageEncoding="ISO-8859-1"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<title>Insert title here</title>
</head>
<body>
<%
//statistics for status
Statistics[] genStatistics = StatisticsQueries.getStatistics();
String statString = Statistics.arrayToString(genStatistics);
//location queries for map
Statistics[] genLocations = StatisticsQueries.getLocations();
String locString = Statistics.arrayToString(genLocations);
//device type queries
Statistics[] genTypes = StatisticsQueries.getDeviceTypes();
String typeString = Statistics.arrayToString(genTypes);
// device manufacturer queries
Statistics[] genManu = StatisticsQueries.getDeviceManu();
String manuString = Statistics.arrayToString(genManu);
%>
	<script type=text/javascript
		src="https://www.gstatic.com/charts/loader.js"></script>
	<script>
var statistics = makeStatistics(); //initialize statistics
var deviceTypes = makeTypes(); //initialize types
var deviceManus = makeManu(); //initialize manufaturers
displayData(); //run the function

function displayData() {
	var html = "";
	var htmlend = "";
	var totalDevices = 0;
	
	/*
	var availableDevices=0;
	var loanDevices=0;
	var lostDevices=0;
	//umbrella sections
	var pendingDevices=0;
	var unavailDevices=0;
	var returnDevices=0;
	var brokenDevices=0;
	*/
	if (statistics.status != "" && statistics.count != ""){
		
		for (var i = 0; i<statistics.length; i++){
			totalDevices = totalDevices + statistics[i].count;
			htmlend += '<br>' + statistics[i].status + ': ' + statistics[i].count;
		}		
		
		html += '<div class = "info-container">Total Devices: '+ totalDevices;
		html += htmlend + '</div>';
		
		// Load the Visualization API and the corechart package.
      	google.charts.load('current', {'packages':['corechart']});

      	// Set a callback to run when the Google Visualization API is loaded.
      	google.charts.setOnLoadCallback(drawPie);
      	google.charts.setOnLoadCallback(drawCol);
      	google.charts.setOnLoadCallback(drawTypesBar);
      	google.charts.setOnLoadCallback(drawManuBar);
      	google.charts.setOnLoadCallback(drawTypesPie);
      	google.charts.setOnLoadCallback(drawManuPie);

      	// Callback that creates and populates a data table,
      	// instantiates the pie chart, passes in the data and
      	// draws it.
     	function drawPie() {
		
		// Create the data table.
        	var data = new google.visualization.DataTable();
        	data.addColumn('string', 'Status');
        	data.addColumn('number', 'Count');
        	for (var i = 0; i<statistics.length; i++){
        		data.addRow([statistics[i].status, statistics[i].count]); //fixed this to match the new database
        	}
        	// Set chart options
        	var options = {'title':'Percentage Chart of Device Statuses',
                       		'width':600,
                       		'height':400,
                       		'backgroundColor':'#E9EAEB'};

        	// Instantiate and draw our chart, passing in some options.
        	var chart = new google.visualization.PieChart(document.getElementById('piechart'));
        	chart.draw(data, options);
        
		}
     	
      	function drawCol() {
      		var data = new google.visualization.DataTable();
      		data.addColumn('string', 'Status');
        	data.addColumn('number', 'Count');
        	for (var i = 0; i<statistics.length; i++){
        		data.addRow([statistics[i].status,statistics[i].count]);
			}
        	
        	var view = new google.visualization.DataView(data);
            view.setColumns([0, 1,
                             { calc: "stringify",
                               sourceColumn: 1,
                               type: "string",
                               role: "annotation" }
                             ]);
            
        	var options = {'title':'Devices in terms of Status',
               		'width':600,
               		'height':400,
               		'bar': {groupWidth: "75%"},                    
               		'legend': { position: "none" },
               		'backgroundColor':'#E9EAEB'};

			// Instantiate and draw our chart, passing in some options.
			var chart = new google.visualization.ColumnChart(document.getElementById('colchart'));
			chart.draw(view, options);
      	}
      	
		function drawTypesBar() {
    		
    		// Create the data table.
            	var data = new google.visualization.DataTable();
    			var otherDevices = 0;
            	data.addColumn('string', 'Device Type');
            	data.addColumn('number', 'Count');
            	var mainTypeArray = ['Computer','Smartphone','Tablet','Camera','Storage Device'];
            	for (var i = 0; i<deviceTypes.length; i++){
            		if (mainTypeArray.indexOf(deviceTypes[i].type) < 0) {
            			otherDevices += deviceTypes[i].count;
            		}
            		else {
                		data.addRow([deviceTypes[i].type, deviceTypes[i].count]); //fixed this to match the new database
            		}
            	}
            	data.addRow(["Other",otherDevices]);
            	var view = new google.visualization.DataView(data);
                view.setColumns([0, 1,
                                 { calc: "stringify",
                                   sourceColumn: 1,
                                   type: "string",
                                   role: "annotation" }
                                 ]);
                
            	var options = {'title':'Devices in terms of Type',
                   		'width':600,
                   		'height':400,
                   		'bar': {groupWidth: "75%"},                    
                   		'legend': { position: "none" },
                   		'backgroundColor':'#E9EAEB'};

    			// Instantiate and draw our chart, passing in some options.
    			var chart = new google.visualization.BarChart(document.getElementById('bartypechart'));
    			chart.draw(view, options);

    		}
		
		function drawManuBar() {
    		
    		// Create the data table.
            	var data = new google.visualization.DataTable();
            	data.addColumn('string', 'Manufacturer');
            	data.addColumn('number', 'Count');
            	var otherDevices = 0;
            	var mainManuArray = ['Apple','Amazon','Microsoft','Samsung','Intel'];
            	
            	for (var i = 0; i<deviceManus.length; i++){
            		if (mainManuArray.indexOf(deviceManus[i].manu) < 0) {
            			otherDevices += deviceManus[i].count;
            		}
            		else {
                	data.addRow([deviceManus[i].manu, deviceManus[i].count]); //fixed this to match the new database
            		}
            	}
            	data.addRow(["Other",otherDevices]);
            	var view = new google.visualization.DataView(data);
                view.setColumns([0, 1,
                                 { calc: "stringify",
                                   sourceColumn: 1,
                                   type: "string",
                                   role: "annotation" }
                                 ]);
                
            	var options = {'title':'Devices in terms of Manufacturer',
                   		'width':600,
                   		'height':400,
                   		'bar': {groupWidth: "75%"},                    
                   		'legend': { position: "none" },
                   		'backgroundColor':'#E9EAEB'};

    			// Instantiate and draw our chart, passing in some options.
    			var chart = new google.visualization.BarChart(document.getElementById('barmanuchart'));
    			chart.draw(view, options);

    		}
		function drawTypesPie() {
			
			// Create the data table.
	        	var data = new google.visualization.DataTable();
	        	data.addColumn('string', 'Hardware Type');
	        	data.addColumn('number', 'Count');
	        	var otherDevices = 0;
	        	var mainTypeArray = ['Computer','Smartphone','Tablet','Camera','Storage Device'];
            	for (var i = 0; i<deviceTypes.length; i++){
            		if (mainTypeArray.indexOf(deviceTypes[i].type) < 0) {
            			otherDevices += deviceTypes[i].count;
            		}
            		else {
                		data.addRow([deviceTypes[i].type, deviceTypes[i].count]); //fixed this to match the new database
            		}
            	}
            	data.addRow(["Other",otherDevices]);
	        	// Set chart options
	        	var options = {'title':'Percentage Chart of Hardware Types',
	                       		'width':600,
	                       		'height':400,
	                       		'backgroundColor':'#E9EAEB'};

	        	// Instantiate and draw our chart, passing in some options.
	        	var chart = new google.visualization.PieChart(document.getElementById('pietypechart'));
	        	chart.draw(data, options);
	        
			}
		function drawManuPie() {
			
			// Create the data table.
	        	var data = new google.visualization.DataTable();
	        	data.addColumn('string', 'Manufacturer');
	        	data.addColumn('number', 'Count');
	        	var otherDevices = 0;
            	var mainManuArray = ['Apple','Amazon','Microsoft','Samsung','Intel'];
            	
            	for (var i = 0; i<deviceManus.length; i++){
            		if (mainManuArray.indexOf(deviceManus[i].manu) < 0) {
            			otherDevices += deviceManus[i].count;
            		}
            		else {
                	data.addRow([deviceManus[i].manu, deviceManus[i].count]); //fixed this to match the new database
            		}
            	}
            	data.addRow(["Other",otherDevices]);
	        	// Set chart options
	        	var options = {'title':'Percentage Chart of Manufacturers',
	                       		'width':600,
	                       		'height':400,
	                       		'backgroundColor':'#E9EAEB'};

	        	// Instantiate and draw our chart, passing in some options.
	        	var chart = new google.visualization.PieChart(document.getElementById('piemanuchart'));
	        	chart.draw(data, options);
	        
			}
     	document.getElementById('stats').innerHTML = html;
	}
}

//map
function initMap() { 
	var locationArray = makeLocations();
	var locations=[];
	  for (var i = 0; i<locationArray.length; i++){
		  var locObject = {lat: parseFloat(locationArray[i].lat),lng: parseFloat(locationArray[i].lng)};
		  locations.push(locObject);
	  }
	
    var map = new google.maps.Map(document.getElementById('map'), {
      zoom: 4,
      center: {lat: 39.023617, lng: -94.69357}
    });

    // Create an array of alphabetical characters used to label the markers.
    var labels = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';

    // Add some markers to the map.
    // Note: The code uses the JavaScript Array.prototype.map() method to
    // create an array of markers based on a given "locations" array.
    // The map() method here has nothing to do with the Google Maps API.
    var markers = locations.map(function(location, i) {
      return new google.maps.Marker({
        position: location,
        label: labels[i % labels.length]
      });
    });

    // Add a marker clusterer to manage the markers.
    var markerCluster = new MarkerClusterer(map, markers,
        {imagePath: 'https://developers.google.com/maps/documentation/javascript/examples/markerclusterer/m'});
  }
  
  /* hardcoded
  var locations = [
	{lat: 37.774929, lng: -122.419416}, //San Francisco, CA
	{lat: 14.599512, lng: 120.984219}, //Manilla, Philippines
	{lat: 17.385044, lng: 78.486671}, //Hyderabad, India
    {lat: 41.878114, lng: -87.629798}, //Chicago, IL
    {lat: 41.053430, lng: -73.538734}, //Stamford, CT
    {lat: 41.053430, lng: -73.538734} //Stamford, CT
  ]
  */
  
function makeStatistics(){
	window.json = '<%=statString%>';
			return JSON.parse(window.json);
		}
function makeLocations(){
	window.json = '<%=locString%>';
			return JSON.parse(window.json);
		}
function makeTypes(){
	window.json = '<%=typeString%>';
			return JSON.parse(window.json);
		}
function makeManu(){
	window.json = '<%=manuString%>';
			return JSON.parse(window.json);
		}
	</script>
	
</body>
</html>